<?php
/**
 * SugarCRM Soap Modules Listing PHP file
 * @package SugarSoap
 * @version v2
 * This uses the Sugar SOAP v2 api (e.g using http://crm.<domain>.com/service/v2/soap.php?wsdl )
 */

//This is the SOAP version 2 login URL, username and password. You'll want to change these to your actual CRM install
//e.g http://demo.sugarcrm.com/service/v2/soap.php?wsdl


$url = 'http://localhost/service/v2/soap.php?wsdl';
$username = 'web_user';
$password = 'thepasswordtologin';


###### You shouldn't need to change anything below this line #####


require_once 'nusoap/lib/nusoap.php';
include_once 'nusoap/lib/class.wsdlcache.php'; //For caching of WDSL files
/**
 * SugarSoap connector class
 *
 * This class makes the process of connecting to and using SugarCRM via the SOAP API much more simplified. e.g It's great for adding on extra features to an online contact form.
 * Note that the class requires the NuSoap files (should be included) and some features will require customisation (e.g the ID's to mailing lists.
 * Based on http://www.beanizer.org/site/index.php/en/Articles/Sugar-CRM-integration-with-custom-PHP-applications-I.html

Resources :

   1. http://www.sugarcrm.com/wiki/index.php?title=Web_Services -- The main entry page for SugarCRM SOAP
   2. SOAP Intro and Practical Examples (php)
   3. Sugar 5.5 Web Services - Design Overview Document (doc) view as HTML
   4. Developer Guide 5.2 'Web Services' section
   5. http://web.lornajane.net/sugar_soap_doc/default/_SugarSoapUsers.php.html -- Generated SugarSoap User function docs.
   6. http://www.beanizer.org/site/index.php/en/Articles/Sugar-CRM-integration-with-custom-PHP-applications-I.html -- Sugar CRM integration with custom PHP applications (I)
   7. http://www.beanizer.org/site/index.php/en/Articles/Sugar-CRM-integration-with-custom-PHP-applications-II.html -- Using SugarCRM as an authentication system
   8. http://systemsconsciousness.com/2009/04/10/sugarcrm-soap-examples/ -- Talks about Wordpress CFORMs to Sugar, although more about the Sugar stuff.
   9. http://systemsconsciousness.com/2009/08/13/sugarcrm-soap-examples-pt-2/ -- SUGARCRM SOAP QUERIES and Google Charts.
  10. http://developers.sugarcrm.com/docs/OS/5.2/-docs-Developer_Guides-Developer_Guide_5.2-DevGuide%205.2.1.34.html -- Developing cloud connectors
  11. http://www.sugarcrm.com/forums/showthread.php?t=44921 -- HOW TO SEARCH BY EMAIL ADDRESS!!!
  12. http://www.sugarcrm.com/forums/showthread.php?t=41421 -- Soap email target list (set relationship?)
  13. http://www.mediarelay.com/resources/item/1-sugarcrm-api-using-soapclient-the-php5-native-soap-implemtntation/1-sugarcrm-api-using-soapclient-the-php5-native-soap-implemtntation.html?start=11900 -- SugarCRM API using PHP5 native SOAP, SoapClient
  14. http://www.osintegra.com/blog/2009/03/18/sugarcrm-entry-points/  -- Adding custom SugarCRM soap entry points.
  15. http://www.sugarcrm.com/forums/showthread.php?t=35179#post119624 -- Set_relationship ordering.
  17. http://www.sugarcrm.com/forums/attachment.php?attachmentid=4139&d=1234347205 --  Sugar 5.5 Web Services, Design Overview Document
  18. http://www.sugarcrm.com/forums/showthread.php?t=26613 -- Using SOAP v2 API in order to remove a relationship (esp to subscribe an unsubscribed user)
  19. http://developers.sugarcrm.com/wordpress/2010/11/16/howto-lookup-email-address-related-to-a-record-via-web-services/ -- Doing an email address lookup
  20. http://developers.sugarcrm.com/wordpress/2010/11/12/howto-search-for-a-record-via-email-address-via-web-services/ -- Searching via email address
 *

Tutorials
    * Tutorial: http://www.sugarforge.org/frs/download.php/216/SugarCRM_SOAP_Overview.rtf (a little dated, March 2005)
    * Good intro to using Sugar's SOAP API: http://www.beanizer.org/index.php3?page=sugar1
    * Getting Started with SugarCRM SOAP API http://systemsconsciousness.com/2009/04/10/sugarcrm-soap-examples/
    * Google Charts and SugarCRM SOAP http://systemsconsciousness.com/2009/08/13/sugarcrm-soap-examples-pt-2/
    * Tutorial on SugarCRM and Perl via SOAP: http://enricosimonetti.com/2009/10/21/integration-between-sugarcrm-and-perl-using-soap/
	 * http://www.ibm.com/developerworks/opensource/library/x-sugarcrmrest/index.html?ca=drs- <-- OMG, SUGARCRM HAS A REST API!!! I should've tried using this (Why don't they document this enough?
    * http://absorbtheweb.com/lead-generation-forms-with-wordpress-and-sugarcrm/ -- Lead Generation Forms with WordPress and SugarCRM

  *
  * Suggestions for working out how to write a Sugar SOAP connector function (like $this->getRelationships which then uses $this->proxy->get_relationships)
 * Check the SOAP output http://crm.anat.org.au/service/v2/soap.php
 * Pay special attention to the attributes. e.g String, Array, Int, etc..
 * Check out the WSDL output for some more detailed but technical information http://crm.anat.org.au/service/v2/soap.php?wsdl
 *
 * Run the $this->outputSOAPModuleFieldsListingHTML() function to get a large listing of the available Modules and their Fields and Linked Fields.
 * Given that it usually takes 20s or more you'll probably want to save the HTML page or at least not run it very often.
 * Usage for the outputSOAPModuleFieldsListingHTML() is in the  file and simply runs :
 *  include_once('../SugarSoap_connector/classes/timer.php');
	 if(class_exists('Timer')) { $timer = new Timer(); } //Nice to know how long it took to run :)
	 include_once '../SugarSoap_connector/classes/SugarSoap_v2.php';
	 $SugarSoap_v2 = new SugarSoap('http://crm.anat.org.au/service/v2/soap.php?wsdl', true); //This is the main class.
	 $SugarSoap_v2->outputSOAPModuleFieldsListingHTML(); //The main call. This does pretty much everything :)
 * @example ../example/SOAP_field_modules_listing_v2.php
 *


http://www.packtpub.com/article/developing-a-simple-workflow-within-sugarcrm -- Sugar Modules, developing a simple workflow within sugar.
 * 
 * {@internal
 * The class can be analysed for examples of how to do various common SugarCRM tasks which happen
 * to be harder than you'd expect. e.g Finding an email address.}}
 *
 * @access public
 * @author Michael Kubler, Technology officer of the Australian Network for Art and Technology {@link mailto:tech@anat.org.au}
 * @copyright Australian Network for Arts and Technology, 2010.  - {@link http://creativecommons.org/licenses/by-sa/2.5/au/ Creative Commons Attribution-ShareAlike 2.5 Australia}
 * @example http://www.anat.org.au/subscribe
 * @version 0.89
 * @package SugarSoap
 * @todo Short Term stuffs
 *  - Include proper error checking for including the nusoap libraries
 *  - Ensure the documentation is correct.
 *  - change the $ANAT_digest_id and $synapse variables to more generic names before going public.
 *  - Include some examples and write up a how-to doc on http://w00t.anat.org.au
 *  - Port over the possible fields listing script.
 *  - Add debugging levels.
 *  - Remove ANAT and Synapse digest id information and move it to the Form2Sugar class
 * @todo Long Term stuff
 *	 <ol>
 *		<li>Add robustness and error checking.</li>
 *		<li><ol>
 *		  <li>Add an empty testing function for Naigos?</li>
 *		  <li>Add possible error emailing function.</li>
 *		  <li>Add Debug levels</li>
 *		</ol></li>
 *		<li>Add bulk contacts list to mailing list</li>
 *		<li>More bulk handling functions</li>
 *	 </ol>
 */
class SugarSoap
{
  /**
   * Proxy object
   * This stores 
   * @var object
   * @access private The connection to SugarCRM's soap API
   */
  var $proxy;

  /**
   * Session information
   * 
   * @var string (number)
   * @access private The current session connection ID
   */
  var $sess;

  /**
   * Error Message
   * @var string The Error message
   */
  var $error;
  /**
   * User Name
   * @var string SugarCRM user login name
   */
  protected $user_name = 'admin'; // Default Username to login with

  /**
	* Password
	* Insert your SugarCRM login password
	* This is later MD5 hashed. If you are worried about security or speed you could put the MD5 hash string here and remove the MD5 hashing from {@link login}
	* @var string The SugarCRM user login password
	*/
  protected $password = '******'; // Deafult Password to try and login with

  /**
   * URL to the SugarCRM Soap connector.
   * e.g http://crm.yourdomain.com/soap.php?wsdl';
   * @var string URL to the SugarCRM soap wsdl page
   */
  var $soap_url = 'http://localhost/service/v2/soap.php?wsdl'; //This is the default URL..


  /**
   * Constructor
   *
   * When you create the SugarSoap object it will automatically attempt to login. Will return true if logged in successfully or false if failed.
   * @param string $soap_url
   * @param Boolean $login
   * @return Boolean
   * @todo Add better nusoap checking, errors and debugging information.
   */
  function SugarSoap($soap_url=null,$user_name=null, $password=null)
  {
  	## Check defaults ##
	if(is_null($soap_url)) {$soap_url = $this->soap_url;} else {$this->soap_url = $soap_url; }
	if(is_null($user_name)) {$user_name = $this->user_name;} else {$this->user_name = $user_name;}
	if(is_null($password)) {$password = $this->password;} else {$this->password = $password;}
	 //echo "Logging into '$this->soap_url' with username '$this->user_name' and password : '$this->password'\n<br/>\n"; //For Debugging...
	 $cache = new nusoap_wsdlcache('.', 86400); // Note that the current directory '.' needs to be writable by the file server. Could change it to /tmp or something if you need.
	 $wsdl = $cache->get($this->soap_url);
	 if(is_null($wdsl)) //If the Cache is empty retrieve the latest version of the WDSL info.
	 {
	   $wsdl = new wsdl($this->soap_url); /*
		 * wsdl Parameters:
			 string   	$wsdl   	WSDL document URL
			 string   	$proxyhost
			 string   	$proxyport
			 string   	$proxyusername
			 string   	$proxypassword
			 integer   	$timeout   	set the connection timeout
			 integer   	$response_timeout   	set the response timeout
			 array   	$curl_options   	user-specified cURL options
			 boolean   	$use_curl   	try to use cURL
			*/
		$cache->put($wsdl);
	 }
	  	 $soapclient = new nusoap_client($wsdl, 'wsdl');

		 /* 
		  * nusoap_client Parameters:
				mixed   	$endpoint   	SOAP server or WSDL URL (string), or wsdl instance (object)
				mixed   	$wsdl   	optional, set to 'wsdl' or true if using WSDL
				string   	$proxyhost   	optional
				string   	$proxyport   	optional
				string   	$proxyusername   	optional
				string   	$proxypassword   	optional
				integer   	$timeout   	set the connection timeout
				integer   	$response_timeout   	set the response timeout
				string   	$portName   	optional portName in WSDL document
		  */

	 /* //Old way, without the wsdlcache
	 $soapclient = new nusoap_client($soap_url,true);
	  */
		 //print_r($soapclient);
	 $this->proxy = $soapclient->getProxy();
	 if($this->proxy == null) //If the URL was wrong or we couldn't access the Internet then error.
	 {
		$this->error .= "<h3>Error with SugarSoap->login()</h3>\n<p><strong>Unable to access the SugarCRM Soap v2 URL</strong><br />\nPlease check the URL address, ensure you are online and try again<br /><br /><em>Attempted to access <a href=\"$this->soap_url\" target=\"_blank\">$this->soap_url</a></em><p>\n";
		return false;
	 }
	 return ($this->login()); //Returns True if it logged in, false if it errored.
  }

  ###################################
  ## Login to SugarCRM Soap (WDSL) ##
  ###################################

  /**
   * Login
   * @access private
   * @return session
   */
  function login()
  {
    $params = array
	 (
		'user_name' => $this->user_name, //Set this to the user you want.
		'password'  => md5($this->password), //You'll need to put your password here.
		//'version'   => '.01'
    );
	 $result = $this->proxy->login($params,'SugarCRM',false); //Do the actual Login to SugarCRM
//print_r($result);
    if(empty($result) || $result['faultcode'] > 0)
	 {
		$this->error .= "<h3>Error with SugarSoap->login()</h3>\n<p><strong>". $result['faultstring'] . "</strong><br />\n" .  $result['detail']. "<br /><br /><em>Attempted to login to <a href=\"$this->soap_url\" target=\"_blank\">$this->soap_url</a> with the username of '<strong>$this->user_name</strong>'</em><p>\n";
		return false;
	 } else {
		$this->sess=$result['id'];
		return true;
	 }
    
  }

  /**
   * SugarCRM Soap Modules and Fields Listing
   *
   * @todo : Output an XML format of the Linked fields for use in the Multipath visualsation flash app.
   * This function is designed to be run on a page of it's own. It can take a while to output everything, but you usually only have to run it once then print it
   * to get an idea of what modules and fields you can access and what SugarCRM calls them.
   * NOTE : THIS FUNCTION USUALLY TAKES A LONG TIME TO RUN! Expect
   * Based on {@link http://www.sugarcrm.com/wiki/index.php?title=SOAP_Intro_and_Practical_Examples}
   * With influence by {@link http://www.lornajane.net/posts/2008/SugarCRM-SOAP-API-Examples} and {@link http://www.thew.id.au/technical/using-soap-and-sugar-crm.html}
   * @param boolean Timer When enabled outputs basic timing/request information.
   * @returns HTML output
   */
  function outputSOAPModuleFieldsListingHTML($timer_mode = true)
  {
	 echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
			 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
			 <title>SOAP Module Field Displayer</title>

  <style  type="text/css">
 .time
  {
	 color: grey;
  }
 .stopwatch
  {
	 font-size: 50%;
  }
 .error strong
  {
	 color: #49f;
  }
 .error em
  {
	 color: #496;
  }
  
 ul#modules li strong
  {
	 color: blue;
  }
  
 a
  {
	 text-decoration: none;
  }
 a:hover
 {
	 text-decoration: underline;
  }

 .linked_fields
  {
	 color: #363;
  }
 .linked_fields li
  {
	 color: #222;
  }
 .linked_fields h3
  {
	 color : #131;
  }
/*
  .module
  {
	 background-color:#EEEEEE;
	 border:2px solid #CCCCCC;
	 padding-left:1em;
  }
  */
  </style>
</head>
<body>';

  //require_once('classes/timer.php'); 
  //$timer = new Timer();

  ########################## HEADER #############
  echo "<h1>SugarCRM SOAP Modules and Fields listing</h1>\n";

  if($timer_mode == true)
  {
	 include_once "timer.php"; //This is a customised version of the class available at http://www.phpclasses.org/browse/file/1378.html and should be in the same directory as the SugarSoap.php class, unless you want to adjust it to look somewhere else.
	 if(class_exists('Timer')) 
	 {
		$timer = new Timer();
	   echo"<p>SugarCRM server info is :<br />\n";
		foreach ($this->proxy->get_server_info() as $field => $value)
		{
		  echo "$field : <strong>$value</strong><br />\n";
		}

		echo"</p>\n";
		echo"<p style='font-size: 80%; text-decoration: underline;'>Address : $this->soap_url</p>\n";
	 }
  }


  ###### GET MODULES LISTING #######
  $modules = $this->proxy->get_available_modules($this->sess);

  echo "<h2>Get Available Modules</h2>\n";

  echo "<ol id='modules'>\n";
  foreach($modules['modules'] as $module)
  {
	 echo "<li><strong><a href='#$module' title='$module'>$module</a></strong></li>\n";
  }
  echo "</ol>\n";


$field_number = 0; //Used to track the module numbers.
  ###### MAIN FOREACH ####
  foreach($modules['modules'] as $module)
  {
	 $field_number++;
	 $result = $this->proxy->get_module_fields($this->sess, $module); ////This gets the fields for the module

	 ?>
	 <div class='module <?php echo $module; ?>'>
	 <?php
	 echo "<a name='$module'></a>\n";
	 if(!empty($module['faultcode']) && $timer_mode === false) //Don't output anything if the module has failed and the Timer Mode is false (Should be called clean output mode)
	 {
		echo '</div>';
	 }
	elseif(isset($result['faultcode'])) //If empty or array
	  {
		 echo "<h2>[$field_number] '$module'</h2>\n";
		 echo '</div>';
	  }
	  else
	  { //Main module name and field listing output.
		echo "<h2>[$field_number] '$module' fields</h2>\n";


		if(empty($result['module_fields'])) //If it's not a normal set of field values then output the errors
		{
			if(!empty($result['error']))
			{
				echo "<p class='error'><strong>" .$result['error']['name'] .'</strong> <em>'. $result['error']['description']."</em></p>\n";
			}
			else //The results aren't normal results, but isn't an error either...
			{
				print_r($result);
			}
		}
		else //It's got the normal module fields, so output those nicely
		{
			echo '<ol>';
			foreach($result['module_fields'] as $fields)
			{
			echo '<li><strong>'.$fields['name'].'</strong>';

			## OUTPUT ENUM FIELD OPTIONS ##
			 if(!empty($fields['options']))
			 {
				 echo ' - ';
				 for ($i = 0; $i < count($fields['options']) ; $i++)
					 {
					 if('' != $fields['options'][$i]['name']) //Some field names are empty, which is annoying to view.
						{
							if($i == count($fields['options']) -1)
							{
								 echo $fields['options'][$i]['name'];
							}
							else
							{
								 echo $fields['options'][$i]['name'] .', ';
							}
						}
					 }
			  }
			  echo "</li>\n"; //End field name
			}
			echo "</ol>\n"; //End module listing
			if(is_array($result['link_fields']))
			 {
				echo "<div class=\"linked_fields\">
				  <h3>Linked Fields for $module</h3>\n\t<p>";
				foreach($result['link_fields'] as $links)
				{
				  echo "<strong>{$links['name']}</strong><br />\n\t\t<ul class='link_fields'>\n";
				  foreach ($links as $link_field => $link_value)
				  {
					 if(!empty($link_value))
						{
						  echo "\t\t\t<li>[$link_field] -> '$link_value'</li>\n";
						}
				  }
				  echo "\t\t</ul>\n<br />\n";
				}
				echo "\t\t</p>\n\t</div>";
			 } //End Linked Field listing
		}
		 if($timer_mode){ $timer->output_stopwatch();} //Display the amount of time it took to run the query since the last stopwatch was set.
		?>
		</div>

	 <br />
	 <hr />
	 <br />
		<?php
		flush(); //Output the latest info so the user know's it's processing... This script can take while, like 20 seconds or more.
		}
	} //end main foreach

  ?>
  <br />
  <?php
  if($timer_mode){ $timer->end(); }
  ## END ModuleFieldOutputter ##
  }

#########################
## End SugarSoap class ##
#########################
}



#######################
## Start Timer class ##
#######################

/**
 * This timer class is an edited version from http://www.phpclasses.org/browse/file/1378.html
 * example useage :
$timer = new Timer();
// Do Stuff
echo "This page took " . $timer->elapsed. "seconds to generate<br />\n";
 * Alternatively you could use the following at the end :
$timer->end();
 */
class Timer {

	var $classname = "Timer";
	var $start     = 0;
	var $stop      = 0;
	var $elapsed   = 0;
	var $stopwatch = 0;

   # Constructor
   function Timer( $start = true ) {
      if ( $start )
         $this->start();
   }

   # Start counting time
   function start() {
      $this->start = $this->_gettime();
   }

   # Stop counting time
   function stop() {
      $this->stop    = $this->_gettime();
      $this->elapsed = $this->_compute();
   }

   # Get Elapsed Time
   function elapsed() {
      if ( !$elapsed )
         $this->stop();

      return $this->elapsed;
   }

	   # Get Elapsed Time
   function end() {
      $this->stop();
		printf("<p class=\"time\">This page took %s seconds to generate</p>\n",  number_format($this->elapsed, 3));
   }

	function end_plain_return() {
      $this->stop();
		return sprintf("This took %s seconds to process\n",  number_format($this->elapsed, 3));
   }


	function stopwatch()
	{
	  $startTime = $this->stopwatch;
	  $this->stopwatch = $this->_gettime();
	  return ($this->stopwatch - $startTime);
	}
	function output_stopwatch()
	{
	  printf("<p class=\"time stopwatch\">This took %s seconds to generate</p>\n",  number_format($this->stopwatch(), 4));
	}

   # Get Elapsed Time
   function reset() {
      $this->start   = 0;
      $this->stop    = 0;
      $this->elapsed = 0;
   }

   #### PRIVATE METHODS ####

   # Get Current Time
   function _gettime() {
      $mtime = microtime();
      $mtime = explode( " ", $mtime );
      return $mtime[1] + $mtime[0];
   }

   # Compute elapsed time
   function _compute() {
      return $this->stop - $this->start;
   }
#######################
## End Timer class ##
#######################
}


###############################
## SugarSoap Controller code ##
###############################
	 //Try logging in.
	 $SugarSoap_v2 = new SugarSoap($url,$username, $password); //The $url, $username and $password are specified at the top of this file.
	 if($SugarSoap_v2->error != "") //Damn, it didn't login :(
	 {
		echo "<div style=\"border: 2px solid #FF0000; width: 50%;padding: .5em 1em .5em 1em; background-color: #FCEFEF; color: #A00000\">
		$SugarSoap_v2->error
	   </div>";
	 }
	 else //Yay! it logged in!
	 {
		$SugarSoap_v2->outputSOAPModuleFieldsListingHTML(); //The main call. This does pretty much everything :)
	 }

?>
</body>
</html>
